## pajeng 1.3.4

=== CMakeLists.txt ===
# This file is part of PajeNG
#
# PajeNG is free software: you can redistribute it and/or modify it
# under the terms of the GNU Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# PajeNG is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Public License for more details.
#
# You should have received a copy of the GNU Public License
# along with PajeNG. If not, see <http://www.gnu.org/licenses/>.
CMAKE_MINIMUM_REQUIRED (VERSION 2.8)
PROJECT(pajeng)
# The following line should be deleted in some Ubuntu releases
cmake_policy(SET CMP0050 OLD)
enable_testing()
SET(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release" FORCE)

SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
set(LIB_INSTALL_DIR lib${LIB_SUFFIX} CACHE PATH "Directory where libraries are installed (relative to CMAKE_INSTALL_PREFIX).")

# the cmake options
OPTION(PAJE_LIBRARY "The Paje library with all the basic components" ON)
OPTION(PAJE_TOOLS     "Compile auxiliary tools (pj_dump, etc)" ON)
OPTION(STATIC_LINKING "Static linking of auxiliary tools" OFF)
OPTION(PAJE_DOC "The Paje Trace File documentation" OFF)

add_subdirectory(src)
if(PAJE_DOC)
  add_subdirectory(doc)
endif(PAJE_DOC)
find_package(Boost)
if(Boost_FOUND)
   include_directories(${Boost_INCLUDE_DIRS})
endif()

install(PROGRAMS ${CMAKE_HOME_DIRECTORY}/scripts/pj_gantt DESTINATION bin)

=== doc/CMakeLists.txt ===
add_custom_target(man ALL)
find_package(ASCIIDoc REQUIRED)

foreach (_INPUT pj_equals.1.txt pj_dump.1.txt)
  string(REPLACE "." ";" LIST ${_INPUT})
  list(REMOVE_ITEM LIST "txt")
  list(GET LIST 0 1 VAR)
  string(REGEX REPLACE ";" "." _OUTPUT "${VAR}")

  add_custom_command(
    TARGET man
    SOURCE  ${CMAKE_CURRENT_SOURCE_DIR}/${_INPUT}
    COMMAND ${A2X_EXECUTABLE} --xsltproc-opts=--nonet --doctype manpage --format manpage ${CMAKE_CURRENT_SOURCE_DIR}/${_INPUT} -D ${CMAKE_CURRENT_BINARY_DIR}
    OUTPUTS ${CMAKE_CURRENT_BINARY_DIR}/${_OUTPUT}
    )

  add_custom_command(
    TARGET man
    SOURCE man
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${_OUTPUT}
    )

  install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${_OUTPUT} DESTINATION ${CMAKE_INSTALL_PREFIX}/man/man1)

endforeach(_INPUT)

add_subdirectory (${CMAKE_HOME_DIRECTORY}/doc/lang-paje/)

=== doc/lang-paje/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

include(../../cmake/UseLATEX.cmake)

add_latex_document(lang-paje.tex DEFAULT_PDF INPUTS definitions.tex)

=== src/libpaje/CMakeLists.txt ===
# This file is part of PajeNG
#
# PajeNG is free software: you can redistribute it and/or modify it
# under the terms of the GNU Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# PajeNG is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Public License for more details.
#
# You should have received a copy of the GNU Public License
# along with PajeNG. If not, see <http://www.gnu.org/licenses/>.
CMAKE_MINIMUM_REQUIRED (VERSION 2.8)

FIND_PACKAGE(FLEX REQUIRED)
FIND_PACKAGE(BISON REQUIRED)
FLEX_TARGET(scanner scanner.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.cc COMPILE_FLAGS "-F")
BISON_TARGET(parser parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser.cc VERBOSE parser.output)

# The Paje Library (libpaje)
SET(LIBPAJE_HEADERS
  PajeColor.h
  PajeException.h
  PajeProtocols.h
  PajeComponent.h
  PajeContainer.h
  PajeData.h
  PajeEntity.h
  PajeEventDecoder.h
  PajeEventDefinition.h
  PajeTraceEvent.h
  PajeEvent.h
  PajeFileReader.h
  PajeObject.h
  PajeSimulator.h
  PajeProbabilisticSimulator.h
  PajeType.h
  PajeValue.h
  PajeDefinitions.h
  PajeFlexReader.h
  PajeUnity.h
  PajeEnum.h
)
SET(LIBPAJE_SOURCES
  PajeEventDefinition.cc
  PajeTraceEvent.cc
  PajeEvent.cc
  PajeData.cc
  PajeFileReader.cc
  PajeObject.cc
  PajeEventDecoder.cc
  PajeSimulator.cc
  PajeProbabilisticSimulator.cc
  PajeSimulator+Queries.cc
  PajeSimulator+Commands.cc
  PajeComponent.cc
  PajeType.cc
  PajeValue.cc
  PajeEntity.cc
  PajeContainer.cc
  PajeColor.cc
  PajeException.cc
  PajeDefinitions.cc
  ${FLEX_scanner_OUTPUTS}
  ${BISON_parser_OUTPUTS}
  PajeFlexReader.cc
  PajeUnity.cc
)

FIND_PACKAGE(Boost REQUIRED)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES(${CMAKE_HOME_DIRECTORY}/src/libpaje)
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})

IF(STATIC_LINKING)
  # static library
  ADD_LIBRARY(paje_library_static STATIC ${LIBPAJE_SOURCES})
  TARGET_LINK_LIBRARIES(paje_library_static ${FLEX_LIBRARIES})
  SET_TARGET_PROPERTIES(paje_library_static PROPERTIES OUTPUT_NAME paje)
ELSE(STATIC_LINKING)
  # shared library
  ADD_LIBRARY(paje_library SHARED ${LIBPAJE_SOURCES})
  TARGET_LINK_LIBRARIES(paje_library ${FLEX_LIBRARIES})
  SET_TARGET_PROPERTIES(paje_library PROPERTIES OUTPUT_NAME paje)
  SET_TARGET_PROPERTIES(paje_library PROPERTIES
    # bump when new function are added in the library
    VERSION 1.3
    # bump when ABI is broken (symbols removed or parameters changed)
    SOVERSION 2)
  # bump when the API change (new functions in the header file)
  SET(LIBPAJE_APIVERSION 2)
  INSTALL(TARGETS paje_library DESTINATION ${LIB_INSTALL_DIR})
  INSTALL(FILES ${LIBPAJE_HEADERS} DESTINATION include)

  #pkgconfig
  CONFIGURE_FILE (libpaje.pc.cmake libpaje.pc @ONLY)
  INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/libpaje.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
ENDIF(STATIC_LINKING)

#### VERSION CHECK

###############
## GIT version check
##
if(EXISTS ${CMAKE_HOME_DIRECTORY}/.git/)
  execute_process(COMMAND git remote
  COMMAND head -n 1
  WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}/.git/
  OUTPUT_VARIABLE remote
  RESULT_VARIABLE ret
  )
  string(REPLACE "\n" "" remote "${remote}")
  execute_process(COMMAND git config --get remote.${remote}.url
  WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}/.git/
  OUTPUT_VARIABLE url
  RESULT_VARIABLE ret
  )
  string(REPLACE "\n" "" url "${url}")
  #message(STATUS "Git url: ${url}")
  if(url)
    execute_process(COMMAND git --git-dir=${CMAKE_HOME_DIRECTORY}/.git log --pretty=oneline --abbrev-commit -1
    WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}/.git/
    OUTPUT_VARIABLE GIT_VERSION
    RESULT_VARIABLE ret
    )
    string(REPLACE "\n" "" GIT_VERSION "${GIT_VERSION}")
    message(STATUS "Git version: ${GIT_VERSION}")
    execute_process(COMMAND git --git-dir=${CMAKE_HOME_DIRECTORY}/.git log -n 1 --pretty=format:%ai .
    WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}/.git/
    OUTPUT_VARIABLE GIT_DATE
    RESULT_VARIABLE ret
    )
    string(REPLACE "\n" "" GIT_DATE "${GIT_DATE}")
    message(STATUS "Git date: ${GIT_DATE}")
    string(REGEX REPLACE " .*" "" GIT_VERSION "${GIT_VERSION}")

    execute_process(COMMAND git --git-dir=${CMAKE_HOME_DIRECTORY}/.git log --pretty=format:%H -1
                    WORKING_DIRECTORY ${CMAKE_HOME_DIRECTORY}/.git/
                    OUTPUT_VARIABLE LIBPAJE_GITHASH
                    RESULT_VARIABLE ret
                    )
    string(REPLACE "\n" "" LIBPAJE_GITHASH "${LIBPAJE_GITHASH}")

  endif()
elseif(EXISTS ${CMAKE_HOME_DIRECTORY}/.gitversion)
  FILE(STRINGS ${CMAKE_HOME_DIRECTORY}/.gitversion GIT_VERSION)
endif()

if(release)
  set(LIBPAJE_VERSION_STRING "${LIBPAJE_VERSION_STRING}\\nRelease build")
else()
  set(LIBPAJE_VERSION_STRING "${LIBPAJE_VERSION_STRING}\\nDevelopment build")
endif()
if(GIT_VERSION)
  set(LIBPAJE_VERSION_STRING "${LIBPAJE_VERSION_STRING} at commit ${GIT_VERSION}")
endif()
if(GIT_DATE)
  set(LIBPAJE_VERSION_STRING "${LIBPAJE_VERSION_STRING} (${GIT_DATE})")
endif()

configure_file("${CMAKE_HOME_DIRECTORY}/src/libpaje/libpaje_config.h.in" "${CMAKE_BINARY_DIR}/libpaje_config.h" @ONLY IMMEDIATE)

=== src/tools/CMakeLists.txt ===
# This file is part of PajeNG
#
# PajeNG is free software: you can redistribute it and/or modify it
# under the terms of the GNU Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# PajeNG is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Public License for more details.
#
# You should have received a copy of the GNU Public License
# along with PajeNG. If not, see <http://www.gnu.org/licenses/>.
CMAKE_MINIMUM_REQUIRED (VERSION 2.8)

IF(NOT PAJE_LIBRARY)
  MESSAGE(FATAL_ERROR "Enable PAJE_LIBRARY to compile paje tools")
ENDIF(NOT PAJE_LIBRARY)

#pj_dump
ADD_EXECUTABLE(pj_dump pj_dump.cc)
INCLUDE_DIRECTORIES (pj_dump ${PROJECT_SOURCE_DIR}/src/libpaje/)
INCLUDE_DIRECTORIES(${pajeng_SOURCE_DIR}/src/fb/)
include_directories(${CMAKE_BINARY_DIR})
find_package(Boost)
if(Boost_FOUND)
   include_directories(${Boost_INCLUDE_DIRS})
endif()

IF(STATIC_LINKING)
  TARGET_LINK_LIBRARIES(pj_dump paje_library_static)
  IF(APPLE)
    TARGET_LINK_LIBRARIES(pj_dump argp)
  ENDIF(APPLE)
ELSE(STATIC_LINKING)
  TARGET_LINK_LIBRARIES(pj_dump paje_library)
  IF(APPLE)
    TARGET_LINK_LIBRARIES(pj_dump argp)
  ENDIF(APPLE)
ENDIF(STATIC_LINKING)
SET_PROPERTY(TARGET pj_dump PROPERTY RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/pj_dump DESTINATION bin)

#pj_equals
ADD_EXECUTABLE(pj_equals pj_equals.cc)
INCLUDE_DIRECTORIES (pj_equals ${PROJECT_SOURCE_DIR}/src/libpaje/)
INCLUDE_DIRECTORIES(${pajeng_SOURCE_DIR}/src/fb/)
include_directories(${CMAKE_BINARY_DIR})
# FIXME check for libgomp / OpenMP support
set_target_properties(pj_equals PROPERTIES COMPILE_FLAGS "-fopenmp")
target_link_libraries(pj_equals gomp)
find_package(Boost)
if(Boost_FOUND)
   include_directories(${Boost_INCLUDE_DIRS})
endif()

IF(STATIC_LINKING)
  TARGET_LINK_LIBRARIES(pj_equals paje_library_static)
  IF(APPLE)
    TARGET_LINK_LIBRARIES(pj_equals argp)
  ENDIF(APPLE)
ELSE(STATIC_LINKING)
  TARGET_LINK_LIBRARIES(pj_equals paje_library)
  IF(APPLE)
    TARGET_LINK_LIBRARIES(pj_equals argp)
  ENDIF(APPLE)
ENDIF(STATIC_LINKING)
SET_PROPERTY(TARGET pj_equals PROPERTY RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/pj_equals DESTINATION bin)

#
# test with tesh (thanks SimGrid team)
#
#testing the pajeng suite (with pj_dump and pj_validate) through tesh
FILE(COPY ${CMAKE_HOME_DIRECTORY}/tests/scripts/ DESTINATION ${CMAKE_BINARY_DIR}/bin)

# the macro to add tesh'es
SET(TESH_COMMAND perl -I${CMAKE_BINARY_DIR}/bin/ ${CMAKE_BINARY_DIR}/bin/tesh)
MACRO(ADD_TESH NAME)
  SET(ARGT ${ARGV})
  LIST(REMOVE_AT ARGT 0)
  ADD_TEST(${NAME} ${TESH_COMMAND} ${TESH_OPTION} ${ARGT})
ENDMACRO()

# include all tesh scripts in the tests directory
FILE(GLOB tests "${CMAKE_HOME_DIRECTORY}/tests/*.tesh")
LIST(SORT tests)
FOREACH(file ${tests})
  STRING(REGEX REPLACE "^.*/tests/" "" name ${file})
  STRING(REGEX REPLACE ".tesh$" "" testname ${name})
  ADD_TESH(${testname}  --cd "${CMAKE_BINARY_DIR}" ${file})
ENDFOREACH()

=== debian/changelog ===
pajeng (1.3.4-3build1) bionic; urgency=medium

  * No-change rebuild to pick up the shared flex library.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 20 Feb 2018 07:10:19 +0000

pajeng (1.3.4-3) unstable; urgency=medium

  [Martin Quinson]
  * Move build-depends from asciidoc to asciidoc-base (Closes: #850375).
  * Fix some Lintian issues:
    - vcs-field-uses-insecure-uri vcs-browser (use https)
    - spelling-error-in-binary (new file: d/patches/typo-lintian)
    - debian-rules-parses-dpkg-parsechangelog
  - d/control: update Standards-Version: 4.0.0 (no further change needed)
  
  [Gregor Herrmann]
  * Fix "pajeng FTBFS with perl 5.26":
    add a patch to escape the literal left braces in regexps.
    (Closes: #870213)

 -- Martin Quinson <mquinson@debian.org>  Tue, 01 Aug 2017 11:41:52 +0200

pajeng (1.3.4-2) unstable; urgency=medium

  * Add libfl-dev to the Build-deps (Closes: #846446).

 -- Martin Quinson <mquinson@debian.org>  Thu, 01 Dec 2016 09:10:15 +0100

pajeng (1.3.4-1) unstable; urgency=medium

  * New upstream release. This should fix yet another FTBFS in viva.
    - Any Qt dependency were droped upstream
  * Drop d/p/fix-viva and d/p/no-boost-moc-ftbfs, applied upstream.

 -- Martin Quinson <mquinson@debian.org>  Mon, 29 Aug 2016 21:56:27 +0200

pajeng (1.3.1-3) unstable; urgency=medium

  * d/p/fix-viva: Put back the constructor that viva needs.
    Viva FTBFS without it. Thanks to Radovan Birdic for the analysis.
  * d/p/no-boost-moc-ftbfs: protect the inclusions of boost to not break
    viva. This is another FTBFS for Viva actually (closes: #827349).

 -- Martin Quinson <mquinson@debian.org>  Mon, 15 Aug 2016 21:55:06 +0200

pajeng (1.3.1-2) unstable; urgency=medium

  * Remove pj_validate from the package description (Closes: #827793).

 -- Martin Quinson <mquinson@debian.org>  Fri, 24 Jun 2016 10:40:11 +0200

pajeng (1.3.1-1) unstable; urgency=medium

  * New upstream release.
  * Update the package and fix most of the lintian errors.

 -- Martin Quinson <mquinson@debian.org>  Sun, 12 Jun 2016 12:09:45 +0200

pajeng (1.1+git20140604.1d5509f042-2) unstable; urgency=medium

  * Build depend on docbook-xsl to avoid failures when building without
    network connexion. Thanks to Logan Rosen for the report and the fix.
    (Closes: #773406)

 -- Martin Quinson <mquinson@debian.org>  Thu, 18 Dec 2014 08:14:43 +0100

=== debian/control ===
Source: pajeng
Priority: extra
Maintainer: Martin Quinson <mquinson@debian.org>
Uploaders: Lucas Nussbaum <lucas@debian.org>
Build-Depends: debhelper (>= 9.0.0),
 asciidoc-base,
 bison,
 chrpath,
 cmake,
 docbook-xsl,
 docbook-xml,
 flex,
 libboost-dev,
 libfl-dev,
 libxml2-utils,
 xsltproc
Standards-Version: 4.0.0
Section: libs
Homepage: https://github.com/schnorr/pajeng
Vcs-Git: git://anonscm.debian.org/collab-maint/pajeng.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/pajeng.git;a=summary

# Depends on r-base-core since usr/bin/pj_gantt is a R script
Package: pajeng
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends:  ${shlibs:Depends}, ${misc:Depends},
  r-base-core,
  libpaje2 (= ${binary:Version})
Description: space-time view and associated tools for Paje trace files
 PajeNG (Paje Next Generation) is a re-implementation (in C++) and
 direct heir of the well-known Paje visualization tool for the
 analysis of execution traces (in the Paje File Format) through trace
 visualization (space/time view). Auxiliary tools are also available
 to dump to CSV and display gantt charts out of Paje trace files.

Package: libpaje2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Parsing, manipulation and simulation of paje trace files
 The libpaje library features the implementation of the Paje File
 Reader, Event Decoder and Simulator. It is capable of reading trace
 files in the Paje file format and keeping them in memory. Data is
 accessed through a well-defined and efficient interface. You can use
 this library to built new visualization techniques for trace
 analysis, without handling all the parsing of files and how events
 are simulated to rebuilt the behavior of the traced application that
 is meant to be analyzed.
 .
 This package contains the run-time files.

Package: libpaje-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 libpaje2 (= ${binary:Version})
Description: Parsing, manipulation and simulation of paje trace files (dev)
 The libpaje library features the implementation of the Paje File
 Reader, Event Decoder and Simulator. It is capable of reading trace
 files in the Paje file format and keeping them in memory. Data is
 accessed through a well-defined and efficient interface. You can use
 this library to built new visualization techniques for trace
 analysis, without handling all the parsing of files and how events
 are simulated to rebuilt the behavior of the traced application that
 is meant to be analyzed.
 .
 This package contains the development files (headers, etc.)

Package: paje-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
 pajeng (= ${binary:Version}) | libpaje2 (= ${binary:Version})
Description: Debug symbols for the Paje libraries
 The libpaje library features the implementation of the Paje File
 Reader, Event Decoder and Simulator. It is capable of reading trace
 files in the Paje file format and keeping them in memory. Data is
 accessed through a well-defined and efficient interface. You can use
 this library to built new visualization techniques for trace
 analysis, without handling all the parsing of files and how events
 are simulated to rebuilt the behavior of the traced application that
 is meant to be analyzed.
 .
 This package contains detached debugging symbols for the package
 pajeng and for the library libpaje.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DH_OPTIONS=--parallel

DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
libdir := /usr/lib/$(DEB_HOST_MULTIARCH)

# get DEB_VERSION from dpkg itself
include /usr/share/dpkg/pkg-info.mk

%:
	dh $@ $(DH_OPTIONS)

.PHONE: override_dh_auto_install
override_dh_auto_install:
	dh_auto_install
	chrpath -d debian/tmp/usr/bin/pj_dump
	chrpath -d debian/tmp/usr/bin/pj_equals
	mkdir -p debian/tmp$(libdir)
	mv debian/tmp/usr/lib/libpaje* debian/tmp$(libdir)
	mv debian/tmp/usr/lib/pkgconfig debian/tmp$(libdir)
	sed -e 's,/lib$$,/lib/$(DEB_HOST_MULTIARCH),' -i debian/tmp$(libdir)/pkgconfig/libpaje.pc

.PHONY: override_dh_shlibdeps
override_dh_shlibdeps:
	dh_shlibdeps -a -- --warnings=7

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=paje-dbg

.PHONY: override_dh_install
override_dh_install:
	dh_install --fail-missing

clean:
	dh clean $(DH_OPTIONS)
	$(RM) -r build
	$(RM) -r stamp-*
	# if this is a git repository, restore removed files that would have
	# been ignored by dpkg-source
	-test -d .git && git checkout -- $$(git status | \
		sed -e '/^#[[:space:]]*deleted:[[:space:]]*/s/^#[[:space:]]*deleted:[[:space:]]*//p;d' | \
		grep -v '^debian/')

DEB_UPSTREAM_VERSION := $(shell echo $(DEB_VERSION) | sed -e 's/-[^-]*$$//')
GIT_URL = https://github.com/schnorr/pajeng.git

get-orig-source::
	uscan --verbose --force-download

## pajeng 1.3.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,7 @@
 cmake_policy(SET CMP0050 OLD)
 enable_testing()
 SET(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release" FORCE)
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 
 SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
 set(LIB_INSTALL_DIR lib${LIB_SUFFIX} CACHE PATH "Directory where libraries are installed (relative to CMAKE_INSTALL_PREFIX).")
@@ -32,9 +33,5 @@
 if(PAJE_DOC)
   add_subdirectory(doc)
 endif(PAJE_DOC)
-find_package(Boost)
-if(Boost_FOUND)
-   include_directories(${Boost_INCLUDE_DIRS})
-endif()
 
 install(PROGRAMS ${CMAKE_HOME_DIRECTORY}/scripts/pj_gantt DESTINATION bin)

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 add_custom_target(man ALL)
 find_package(ASCIIDoc REQUIRED)
 
-foreach (_INPUT pj_equals.1.txt pj_dump.1.txt)
+foreach (_INPUT pj_equals.1.txt pj_dump.1.txt pj_gantt.1.txt)
   string(REPLACE "." ";" LIST ${_INPUT})
   list(REMOVE_ITEM LIST "txt")
   list(GET LIST 0 1 VAR)

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -23,10 +23,6 @@
 INCLUDE_DIRECTORIES (pj_dump ${PROJECT_SOURCE_DIR}/src/libpaje/)
 INCLUDE_DIRECTORIES(${pajeng_SOURCE_DIR}/src/fb/)
 include_directories(${CMAKE_BINARY_DIR})
-find_package(Boost)
-if(Boost_FOUND)
-   include_directories(${Boost_INCLUDE_DIRS})
-endif()
 
 IF(STATIC_LINKING)
   TARGET_LINK_LIBRARIES(pj_dump paje_library_static)
@@ -49,11 +45,6 @@
 include_directories(${CMAKE_BINARY_DIR})
 # FIXME check for libgomp / OpenMP support
 set_target_properties(pj_equals PROPERTIES COMPILE_FLAGS "-fopenmp")
-target_link_libraries(pj_equals gomp)
-find_package(Boost)
-if(Boost_FOUND)
-   include_directories(${Boost_INCLUDE_DIRS})
-endif()
 
 IF(STATIC_LINKING)
   TARGET_LINK_LIBRARIES(pj_equals paje_library_static)

=== debian/changelog ===
pajeng (1.3.5-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:22:31 +0100

pajeng (1.3.5-1) unstable; urgency=medium

  * New upstream release. 
    - Drop d/p/perl-5.26 and d/p/typo-lintian: integrated upstream.
  * Update VCS fields to point to Salsa.
  * Change priority from extra to optional to obey the policy.
  * Rely on pre-initialized dpkg-architecture variables.
  * Drop the -dbg package as they are now automatically generated.
  * d/rules: drop now obsolete the 'get-orig-source' target.
  * d/rules: Harden the build.
  * Bump Standards-Version: 4.4.1 (induced changes documented above)
  * Bump debhelper compat level to 12 (some cleanups were needed).
  * d/copyright: prefer secure URIs.
  * d/p/no-latex: new patch to not rebuild the Paje reference guide,
    as it require a tex->dvi installation for something we don't install.
    This was not built before, that patch is only needed because we
    now build the manpages.

 -- Martin Quinson <mquinson@debian.org>  Mon, 20 Jan 2020 21:55:20 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: pajeng
-Priority: extra
+Priority: optional
 Maintainer: Martin Quinson <mquinson@debian.org>
 Uploaders: Lucas Nussbaum <lucas@debian.org>
-Build-Depends: debhelper (>= 9.0.0),
+Build-Depends:
+ debhelper-compat (= 12),
  asciidoc-base,
  bison,
  chrpath,
@@ -14,18 +15,18 @@
  libfl-dev,
  libxml2-utils,
  xsltproc
-Standards-Version: 4.0.0
+Standards-Version: 4.4.1
 Section: libs
 Homepage: https://github.com/schnorr/pajeng
-Vcs-Git: git://anonscm.debian.org/collab-maint/pajeng.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/pajeng.git;a=summary
+Vcs-Git: https://salsa.debian.org/debian/pajeng.git
+Vcs-Browser: https://salsa.debian.org/debian/pajeng
 
 # Depends on r-base-core since usr/bin/pj_gantt is a R script
 Package: pajeng
 Architecture: any
 Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
-Depends:  ${shlibs:Depends}, ${misc:Depends},
+Depends: ${shlibs:Depends}, ${misc:Depends},
   r-base-core,
   libpaje2 (= ${binary:Version})
 Description: space-time view and associated tools for Paje trace files
@@ -70,23 +71,3 @@
  is meant to be analyzed.
  .
  This package contains the development files (headers, etc.)
-
-Package: paje-dbg
-Section: debug
-Architecture: any
-Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
-Depends: ${misc:Depends},
- pajeng (= ${binary:Version}) | libpaje2 (= ${binary:Version})
-Description: Debug symbols for the Paje libraries
- The libpaje library features the implementation of the Paje File
- Reader, Event Decoder and Simulator. It is capable of reading trace
- files in the Paje file format and keeping them in memory. Data is
- accessed through a well-defined and efficient interface. You can use
- this library to built new visualization techniques for trace
- analysis, without handling all the parsing of files and how events
- are simulated to rebuilt the behavior of the traced application that
- is meant to be analyzed.
- .
- This package contains detached debugging symbols for the package
- pajeng and for the library libpaje.

## pajeng 1.3.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,8 +14,6 @@
 # along with PajeNG. If not, see <http://www.gnu.org/licenses/>.
 CMAKE_MINIMUM_REQUIRED (VERSION 2.8)
 PROJECT(pajeng)
-# The following line should be deleted in some Ubuntu releases
-cmake_policy(SET CMP0050 OLD)
 enable_testing()
 SET(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release" FORCE)
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

=== src/libpaje/CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 FIND_PACKAGE(FLEX REQUIRED)
 FIND_PACKAGE(BISON REQUIRED)
 FLEX_TARGET(scanner scanner.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.cc COMPILE_FLAGS "-F")
-BISON_TARGET(parser parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser.cc VERBOSE parser.output)
+BISON_TARGET(parser parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser.cc)
 
 # The Paje Library (libpaje)
 SET(LIBPAJE_HEADERS
@@ -69,11 +69,8 @@
   PajeUnity.cc
 )
 
-FIND_PACKAGE(Boost REQUIRED)
-
 INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
 INCLUDE_DIRECTORIES(${CMAKE_HOME_DIRECTORY}/src/libpaje)
-INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
 
 IF(STATIC_LINKING)
   # static library

=== debian/changelog ===
pajeng (1.3.6-4build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:50:16 +0200

pajeng (1.3.6-4) unstable; urgency=medium

  * d/p/fix_legacy_parsing: new patch picked from upstream
    (Closes: #1032193)
  * d/control: Bump standards-version to 4.6.2 (no change needed)

 -- Martin Quinson <mquinson@debian.org>  Mon, 13 Mar 2023 22:52:49 +0100

pajeng (1.3.6-3) unstable; urgency=low

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Martin Quinson ]
  * d/control: Bump to debhelper v13.
  * d/watch: update to version 4 of uscan.
  * d/control: Bump standards-version to 4.6.0 (no change needed)

 -- Martin Quinson <mquinson@debian.org>  Mon, 23 Aug 2021 21:30:28 +0200

pajeng (1.3.6-2) unstable; urgency=medium

  - d/control: update Standards-Version: 4.5.0 (no further change needed)
  * Fix some trailing spaces to please lintian.

 -- Martin Quinson <mquinson@debian.org>  Wed, 29 Apr 2020 11:44:34 +0200

pajeng (1.3.6-1) unstable; urgency=medium

  * New upstream release: flex parser wasn't setting time for events.
    This resulted in a FTBFS on i386 (Closes: #958084).

 -- Martin Quinson <mquinson@debian.org>  Fri, 24 Apr 2020 12:43:35 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: pajeng
 Priority: optional
-Maintainer: Martin Quinson <mquinson@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Martin Quinson <mquinson@debian.org>
 Uploaders: Lucas Nussbaum <lucas@debian.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  asciidoc-base,
  bison,
  chrpath,
@@ -15,7 +16,7 @@
  libfl-dev,
  libxml2-utils,
  xsltproc
-Standards-Version: 4.4.1
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/schnorr/pajeng
 Vcs-Git: https://salsa.debian.org/debian/pajeng.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/pajeng-$1\.tar\.gz/ \
  https://github.com/schnorr/pajeng/tags .*/v?(\d\S+)\.tar\.gz

## pajeng 1.3.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,7 +15,7 @@
 CMAKE_MINIMUM_REQUIRED (VERSION 2.8)
 PROJECT(pajeng)
 enable_testing()
-SET(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release" FORCE)
+SET(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
 
 SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
@@ -26,6 +26,7 @@
 OPTION(PAJE_TOOLS     "Compile auxiliary tools (pj_dump, etc)" ON)
 OPTION(STATIC_LINKING "Static linking of auxiliary tools" OFF)
 OPTION(PAJE_DOC "The Paje Trace File documentation" OFF)
+OPTION(PAJE_USE_FMT "This option uses the FMT library for double-string conversion, if disabled, PajeNG will use boost::karma that presents slight different precision results" ON)
 
 add_subdirectory(src)
 if(PAJE_DOC)

=== src/CMakeLists.txt ===
# This file is part of PajeNG
#
# PajeNG is free software: you can redistribute it and/or modify it
# under the terms of the GNU Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# PajeNG is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Public License for more details.
#
# You should have received a copy of the GNU Public License
# along with PajeNG. If not, see <http://www.gnu.org/licenses/>.
CMAKE_MINIMUM_REQUIRED (VERSION 2.8)

# The Paje Library (libpaje) 
IF(PAJE_LIBRARY)
  add_subdirectory (${CMAKE_HOME_DIRECTORY}/src/libpaje/)
ENDIF(PAJE_LIBRARY)

# Paje tools
IF(PAJE_TOOLS)
  add_subdirectory (${CMAKE_HOME_DIRECTORY}/src/tools)
ENDIF(PAJE_TOOLS)

=== src/libpaje/CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,18 @@
 
 FIND_PACKAGE(FLEX REQUIRED)
 FIND_PACKAGE(BISON REQUIRED)
+
+IF(${PAJE_USE_FMT})
+FIND_PACKAGE(FMT 5.0.0 REQUIRED)
+add_definitions("-DPAJE_USE_FMT")
+endif()
+
+IF(${PAJE_USE_FMT} AND NOT ${FMT_FOUND})
+  message( FATAL_ERROR "\nPackage FMT not found, try installing it (debian package: libfmt-dev).\
+ One option is to disable PAJE_USE_FMT, to fall back to boost::karma.\
+ However, boost::karma presents slight different precision results." )
+endif()
+
 FLEX_TARGET(scanner scanner.l ${CMAKE_CURRENT_BINARY_DIR}/lexer.cc COMPILE_FLAGS "-F")
 BISON_TARGET(parser parser.y ${CMAKE_CURRENT_BINARY_DIR}/parser.cc)
 
@@ -76,11 +88,17 @@
   # static library
   ADD_LIBRARY(paje_library_static STATIC ${LIBPAJE_SOURCES})
   TARGET_LINK_LIBRARIES(paje_library_static ${FLEX_LIBRARIES})
+IF(${PAJE_USE_FMT})
+  TARGET_LINK_LIBRARIES(paje_library_static PRIVATE fmt::fmt-header-only)
+ENDIF()
   SET_TARGET_PROPERTIES(paje_library_static PROPERTIES OUTPUT_NAME paje)
 ELSE(STATIC_LINKING)
   # shared library
   ADD_LIBRARY(paje_library SHARED ${LIBPAJE_SOURCES})
   TARGET_LINK_LIBRARIES(paje_library ${FLEX_LIBRARIES})
+IF(${PAJE_USE_FMT})
+  TARGET_LINK_LIBRARIES(paje_library fmt::fmt)
+ENDIF()
   SET_TARGET_PROPERTIES(paje_library PROPERTIES OUTPUT_NAME paje)
   SET_TARGET_PROPERTIES(paje_library PROPERTIES
     # bump when new function are added in the library

=== debian/changelog ===
pajeng (1.3.7-1) unstable; urgency=medium

  * New upstream release.
  * Drop upstream patch: fix_legacy_parsing

 -- Martin Quinson <mquinson@debian.org>  Sat, 21 Dec 2024 18:52:01 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,6 @@
 Source: pajeng
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Martin Quinson <mquinson@debian.org>
+Maintainer: Martin Quinson <mquinson@debian.org>
 Uploaders: Lucas Nussbaum <lucas@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
@@ -14,6 +13,7 @@
  flex,
  libboost-dev,
  libfl-dev,
+ libfmt-dev,
  libxml2-utils,
  xsltproc
 Standards-Version: 4.6.2

## pajeng 1.3.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 #
 # You should have received a copy of the GNU Public License
 # along with PajeNG. If not, see <http://www.gnu.org/licenses/>.
-CMAKE_MINIMUM_REQUIRED (VERSION 2.8)
+cmake_minimum_required(VERSION 3.20...4.0)
 PROJECT(pajeng)
 enable_testing()
 SET(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release")

=== doc/CMakeLists.txt ===
find_package(ASCIIDoc REQUIRED)

set(MAN_OUTPUTS "")

foreach(_INPUT pj_equals.1.txt pj_dump.1.txt pj_gantt.1.txt)
  # Remove only the .txt suffix → pj_equals.1
  string(REGEX REPLACE "\\.txt$" "" _OUTPUT "${_INPUT}")

  set(_SRC ${CMAKE_CURRENT_SOURCE_DIR}/${_INPUT})
  set(_DST ${CMAKE_CURRENT_BINARY_DIR}/${_OUTPUT})

  add_custom_command(
    OUTPUT ${_DST}
    COMMAND ${A2X_EXECUTABLE} --xsltproc-opts=--nonet
                              --doctype manpage
                              --format manpage
                              ${_SRC}
                              -D ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${_SRC}
    COMMENT "Generating man page ${_OUTPUT}"
    VERBATIM
  )

  list(APPEND MAN_OUTPUTS ${_DST})

  install(FILES ${_DST} DESTINATION ${CMAKE_INSTALL_PREFIX}/man/man1)
endforeach()

add_custom_target(man ALL DEPENDS ${MAN_OUTPUTS})

add_subdirectory (${CMAKE_HOME_DIRECTORY}/doc/lang-paje/)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -12,8 +12,6 @@
 #
 # You should have received a copy of the GNU Public License
 # along with PajeNG. If not, see <http://www.gnu.org/licenses/>.
-CMAKE_MINIMUM_REQUIRED (VERSION 2.8)
-
 # The Paje Library (libpaje) 
 IF(PAJE_LIBRARY)
   add_subdirectory (${CMAKE_HOME_DIRECTORY}/src/libpaje/)

=== doc/lang-paje/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20...4.0)
include(../../cmake/UseLATEX.cmake)
add_latex_document(lang-paje.tex DEFAULT_PDF INPUTS definitions.tex)

=== src/libpaje/CMakeLists.txt ===
--- 
+++ 
@@ -12,8 +12,6 @@
 #
 # You should have received a copy of the GNU Public License
 # along with PajeNG. If not, see <http://www.gnu.org/licenses/>.
-CMAKE_MINIMUM_REQUIRED (VERSION 2.8)
-
 FIND_PACKAGE(FLEX REQUIRED)
 FIND_PACKAGE(BISON REQUIRED)
 
@@ -87,7 +85,7 @@
 IF(STATIC_LINKING)
   # static library
   ADD_LIBRARY(paje_library_static STATIC ${LIBPAJE_SOURCES})
-  TARGET_LINK_LIBRARIES(paje_library_static ${FLEX_LIBRARIES})
+  TARGET_LINK_LIBRARIES(paje_library_static PRIVATE ${FLEX_LIBRARIES})
 IF(${PAJE_USE_FMT})
   TARGET_LINK_LIBRARIES(paje_library_static PRIVATE fmt::fmt-header-only)
 ENDIF()

=== src/tools/CMakeLists.txt ===
--- 
+++ 
@@ -12,8 +12,6 @@
 #
 # You should have received a copy of the GNU Public License
 # along with PajeNG. If not, see <http://www.gnu.org/licenses/>.
-CMAKE_MINIMUM_REQUIRED (VERSION 2.8)
-
 IF(NOT PAJE_LIBRARY)
   MESSAGE(FATAL_ERROR "Enable PAJE_LIBRARY to compile paje tools")
 ENDIF(NOT PAJE_LIBRARY)

=== debian/changelog ===
pajeng (1.3.10-1) unstable; urgency=medium

  * New upstream release.
    - Fix FTBFS with CMake v4 (Closes: #1113386).
  * d/control: Bump standards-version to 4.7.2 (no change needed)

 -- Martin Quinson <mquinson@debian.org>  Fri, 12 Sep 2025 08:43:39 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  libfmt-dev,
  libxml2-utils,
  xsltproc
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/schnorr/pajeng
 Vcs-Git: https://salsa.debian.org/debian/pajeng.git

=== debian/rules ===
--- 
+++ 
@@ -4,16 +4,24 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-DH_OPTIONS=--parallel
-
-DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+# Get some variables from dpkg itself
+include /usr/share/dpkg/architecture.mk
 libdir := /usr/lib/$(DEB_HOST_MULTIARCH)
-
-# get DEB_VERSION from dpkg itself
 include /usr/share/dpkg/pkg-info.mk
 
+# Harden the build
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
+CFLAGS+=$(CPPFLAGS)
+CXXFLAGS+=$(CPPFLAGS)
+
 %:
-	dh $@ $(DH_OPTIONS)
+	dh $@
+
+override_dh_auto_configure:
+	dh_auto_configure -Scmake -- \
+                -DPAJE_DOC=ON \
+		${CMAKE_FLAGS}
 
 .PHONE: override_dh_auto_install
 override_dh_auto_install:
@@ -29,13 +37,11 @@
 override_dh_shlibdeps:
 	dh_shlibdeps -a -- --warnings=7
 
-.PHONY: override_dh_strip
-override_dh_strip:
-	dh_strip --dbg-package=paje-dbg
-
 .PHONY: override_dh_install
 override_dh_install:
-	dh_install --fail-missing
+	dh_install
+	dh_installman
+	dh_missing --fail-missing
 
 clean:
 	dh clean $(DH_OPTIONS)
@@ -47,8 +53,5 @@
 		sed -e '/^#[[:space:]]*deleted:[[:space:]]*/s/^#[[:space:]]*deleted:[[:space:]]*//p;d' | \
 		grep -v '^debian/')
 
-DEB_UPSTREAM_VERSION := $(shell echo $(DEB_VERSION) | sed -e 's/-[^-]*$$//')
-GIT_URL = https://github.com/schnorr/pajeng.git
-
-get-orig-source::
-	uscan --verbose --force-download
+#get-orig-source::
+#	uscan --verbose --force-download
